<?php
if(!defined('ABSPATH')) die; // Die if accessed directly

class DataQlick__CustomersExport extends DataQlick__Export {

    public function get_all_items_count() {
        return count( get_users('role=customer') );
    }

    public function get_items_data() {
        $customers = get_users('role=customer');

        $sliced_customers = array_slice( $customers, ($this->page - 1) * $this->pagesize, $this->pagesize );
        $result = array();

        foreach ( $sliced_customers as $user ) {
            $result[] = self::get_export_data_from_user( $user );
        }

        return $result;
    }

    static public function get_export_data_from_user( $user ) {
        $data = get_user_meta( $user->id );

        return array(
            'id' => $user->id,
            'displayName' => $user->data->display_name,
            'firstName' => $data['first_name'][0],
            'lastName' => $data['last_name'][0],
            'email' => $user->data->user_email,

            'shippingAddress' => array(
                'companyName' => !empty($data['shipping_company'][0]) ? $data['shipping_company'][0] : '',
                'phone' => !empty($data['billing_phone'][0]) ? $data['billing_phone'][0] : '',
                'street' => !empty($data['shipping_address_1'][0]) ? $data['shipping_address_1'][0] : '',
                'city' => !empty($data['shipping_city'][0]) ? $data['shipping_city'][0] : '',
                'state' => !empty($data['shipping_state'][0]) ? $data['shipping_state'][0] : '',
                'zip' => !empty($data['shipping_postcode'][0]) ? $data['shipping_postcode'][0] : '',
                'country' => !empty($data['shipping_country'][0]) ? $data['shipping_country'][0] : '',
                'email' => $user->data->user_email,
            ),

            'billingAddress' => array(
                'companyName' => !empty($data['billing_company'][0]) ? $data['billing_company'][0] : '',
                'phone' => !empty($data['billing_phone'][0]) ? $data['billing_phone'][0] : '',
                'street' => !empty($data['billing_address_1'][0]) ? $data['billing_address_1'][0] : '',
                'city' => !empty($data['billing_city'][0]) ? $data['billing_city'][0] : '',
                'state' => !empty($data['billing_state'][0]) ? $data['billing_state'][0] : '',
                'zip' => !empty($data['billing_postcode'][0]) ? $data['billing_postcode'][0] : '',
                'country' => !empty($data['billing_country'][0]) ? $data['billing_country'][0] : '',
                'email' => $user->data->user_email,
            )
        );
    }

}


